<!DOCTYPE html>
<html>
<head>
  <meta http-equiv="content-type" content="text/html; charset=utf-8" />
  <meta name="viewport" content="width=device-width,initial-scale=1">
  <title>linquizz widget</title>
  <style>
    .qz {
      margin: 4vh auto;
      max-width: 30em;
      background: #f9f9f9;
      padding: 1em;
      border: .2px solid #eee;
      border-radius: 4px;
    }
    .wrp-pg {
      width: 100%;
      height: .4em;
      background: #eee;
      border-radius: 4px;
      overflow: hidden;
    }
    .pg {
      background-image: linear-gradient(-90deg, #7d00ff, #dccf1b);
      width: 0;
      height: 100%;
      transition: width .6s;
      border-radius: inherit;
    }
    #aaa {
      display: none;
    }
    .wrp-c {
      transition: 1s opacity .2s;
    }
    h4 {
      margin: .8em 0;
      color: #333;
      font-weight: 500;
    }
    input {
      position: absolute;
      width: 80%;
      height: 2em;
      opacity: 0;
    }
    input:checked + label {
      background: #dccf1b;
      color: #fff;
    }
    label {
      display: inline-block;
      margin: .4rem auto;
      width: 100%;
      height: 1.8rem;
      color: #444;
      border-radius: 4px;
      font-size: 1.1em;
      padding-top: .5em;
      text-align: center;
      background: #eee;
    }
    .button {
      margin-top: .8em;
      height: 2.2em;
      width: 30%;
      color: #333;
      font-weight: 600;
      border-radius: 4px;
      text-align: center;
      background: #eee;
      outline: none;
      border: none;
    }
    .button:hover {
      background: #7d00ff;
      color: #fff;
    }
  </style>
</head>
<body>
  <div class="qz">
    <div class="wrp-pg">
      <div class="pg"></div>
    </div>
    <div id="aaa">
      <div class="wrp-c">
        <h4>{this.q} -</h4>
        <div>
          <input type="radio" name="option" value="{this.a}" required /><label>{this.a}</label>
          <br />
          <input type="radio" name="option" value="{this.b}" required /><label>{this.b}</label>
          <br />
          <input type="radio" name="option" value="{this.c}" required /><label>{this.c}</label>
          <br />
          <input type="radio" name="option" value="{this.d}" /><label>{this.d}</label>
          <button @click="check" class="button">check</button>
        </div>
      </div>
    </div>
  </div>
  <script type="module">
    import Litedom from './ld.js'
    //json data
    const jata = '[{ "q": "eopkg is a when question is too or atleast a bit long then how it looks like","a": "driver","b":"package manager","c":"shell","d":"application","r":"b"},{"q": "GRUB is a","a": "device driver package","b":"music app","c":"command line utility","d":"boot loader","r":"d"},{"q": "neofetc is used to get","a": "system info","b":"RAM usage info","c":"CPU usage info","d":"detect external devices","r":"a"}]';
    const jData = JSON.parse(jata); //data processing
    
    const pool = jData.length; //total number of question
    let it = 0; //current question index
    let score = 0; //number of correct answer
    Litedom({
      //mounting element
      el: "#aaa",
      //reactive data
      data: {
        i: 0,
        q: (state) => jData[state.i].q,
        a: (state) => jData[state.i].a,
        b: (state) => jData[state.i].b,
        c: (state) => jData[state.i].c,
        d: (state) => jData[state.i].d,
        r: (state) => jData[state.i].r,
        ans: (state) => `${state[state.r]}`,
      },
      //ans check
      check() {
        if (it < pool) {
          //getting DOM nodes
          const checkd = document.querySelector('input:checked');
          const pg = document.querySelector('.pg');
          const sel = document.querySelector('.wrp-c');
          if (checkd != null) {
            //validating answer
            if (this.data.ans == checkd.value) {
              score++;
              checkd.nextSibling.style.transition = "background .2s, color .1s";
              checkd.nextSibling.style.background = "#96e78e";
              checkd.nextSibling.style.color = "#166600";
            } else {
              checkd.nextSibling.style.transition = "background .2s, color .1s";
              checkd.nextSibling.style.background = "#e7968e";
              checkd.nextSibling.style.color = "#661600";
            }
            //updating progress bar
            it++;
            let its = 0;
            its += (100/pool)*it;
            pg.style.width = its + '%';
            //restting styles, updating to next question
            sel.style.pointerEvents = "none";
            sel.style.opacity = 0;
            setTimeout(()=> {
              sel.style.pointerEvents = "";
              sel.style.opacity = 1;
              checkd.nextSibling.style = "";
              checkd.checked = false;
              this.data.i = it;
            }, 1200);
          } else {
            alert('nooo! choose one option plz :(');
          }
        } else {
          alert('all done! ;)');
        }
      }
    })
  </script>
</body>
</html>